% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/image.R
\name{dim.internalImage}
\alias{as.array.internalImage}
\alias{dim.internalImage}
\alias{dim<-.internalImage}
\alias{internalImage}
\title{Internal images}
\usage{
\method{dim}{internalImage}(x)

\method{dim}{internalImage}(x) <- value

\method{as.array}{internalImage}(x, ...)
}
\arguments{
\item{x}{An \code{"internalImage"} object.}

\item{value}{Not used. Changing the dimensions of an internal image is
invalid, and will produce an error.}

\item{...}{Additional parameters to methods. Currently unused.}
}
\description{
An internal image is a simple R object with a few attributes including a
pointer to an internal C structure, which contains the full image data. They
are used in the package for efficiency, but can be converted to a normal
R array using the \code{as.array} method. Attributes of these objects should
not be changed.
}
\author{
Jon Clayden <code@clayden.org>
}

